<?php
# 后台核心配置
# 图标 https://vue-admin-beautiful.com/admin-plus/#/vab/icon/remixIcon
return array
(
    # 系统定义 默认将建立platform和group系统，如果不需要多系统，这里无需定义，多系统一般为多主体服务，菜单中请填写platform即可
    /*
    'system' => array
    (
        'main' => array
        (
            'name' => '测试系统',
            'sort' => '-100',
            # 这个是系统的数据隔离类型，database是分库隔离，table是分表隔离，field是分区隔离，where是字段隔离
            'partition' => 'database',
            # 关联表名
            'relation_table' => 'manage/platform',
            # 关联字段名
            'relation_field' => 'platform_id',
            # 关联用户表表名
            'relation_user_table' => 'manage/admin',
        ),
    ),*/

    # 菜单定义
    'menu' => array
    (
        /* 注释说明
        # 定义父级菜单
        'set' => array
        (
            # 菜单名称
            'name' => '配置',
            # 菜单图标
            'icon' => 'settings-line',
            # 菜单排序 正序
            'sort' => '100',
            # 所属系统 系统key，一般只需主菜单填写system
            'system' => 'platform',
        ),
        # 定义二级菜单
        'platform' => array
        (
            'parent' => 'set',
            'name' => '平台管理',
            'icon' => 'book-open-line',
            'sort' => '200',
        ),
        # 定义三级菜单 一般和manage下的文件名一致
        'admin' => array
        (
            # 所属项目 不填写则获取当前deverapp
            'app'       => 'manage',
            # 上级菜单
            'parent'    => 'platform',
            # 菜单名称
            'name'      => '账户管理',
            # 菜单图标
            'icon'      => 'user-settings-line',
            # 菜单排序 正序
            'sort'      => '1',
            # 菜单路径 可选项：main列表页,update更新页,view详情页,[stat统计页,layout自定义页后续添加]，不填写默认为main
            'path'      => 'main',
            # 标签 这里需要设置获取标签的方法,暂时不支持
            'badge'     => 'test.badge',
            # 不显示在菜单中
            //'show'      => 2,
        ),
        */
        'test_top' => array
        (
            'name' => '测试',
            'icon' => 'test-tube-line',
            'sort' => '1',
            'system' => 'platform',
        ),

        'test' => array
        (
            'parent'    => 'test_top',
            'name'      => '测试组件',
            'icon'      => 'aliens-line',
            'sort'      => '10',
        ),

        'user' => array
        (
            'parent'    => 'test',
            'name'      => '账户管理',
            'icon'      => 'user-settings-line',
            'sort'      => '1',
        ),

        'news' => array
        (
            'parent'    => 'test',
            'name'      => '新闻管理',
            'icon'      => 'article-line',
            'sort'      => '2',
        ),
    ),
);